# Serverless Devs Tool介绍

* 工具名称：Serverless Devs Tool
* 工具类型：命令行工具
* 工具定位：Serverless多云工具
* 工具标志：   
  ![](https://images.serverlessfans.com/s-tool/logo.jpg)   
  标志含义：
    * Serverless Devs Tool是一个多云的Serverless工具，在我国古代三表示多的意思，所以在Logo上面有三条线；
    * 右下用了一个三角形，表示稳固、牢固的意思，就是说我们的这个工具是一个稳定的工具，靠谱的工具；
    * 同时整个logo又是一个点击的样子，证明我们的工具是只需要点击一下就可以为您打开Serverless的新世界，表现工具的简单、方便与快速。
* 所属组织：Serverless Devs（Serverless Devs是一群Serverless爱好者，共建的一个Serverless生态，开源+开放，我们要做的不是为某个厂商而存在的工具，我们要做的是为开发者而存在的工具！）
* 工具简介：    
  &nbsp;&nbsp;&nbsp;&nbsp;Serverless Devs Tool，实际上是一个开源开放的Serverless命令行工具，我们创建这个工具的最初的原因是，目前各个云厂商都在玩自己的Serverless，都在做自己的工具，与自身绑定严重，与社区割裂开来。这种情况对于我们开发者而言，是非常可怕的，因为这将会给我们很多开发者极大的不安全感。迁移复杂，各厂规范标准不同，这又让Serverless成为了一个"只可远观而不可亵玩焉"的产品。    
  &nbsp;&nbsp;&nbsp;&nbsp;基于以上种种原因，我和一群热爱Serverless的小伙伴不约而同，一拍即合，决定做一个"真正的"厂商无绑定的Serverless命令行工具。该工具，将会努力在体验层面做规范和统一，我们的一个简单的，也很苦难的想法是，用户在使用某些上层能力的时候，可以直接通过修改云厂商的名字，就可以将项目部署在不同的云厂商上，想一想这就将会是一个非常Cool的事情。    
  &nbsp;&nbsp;&nbsp;&nbsp;我知道有很多小伙伴们都很好奇目前咩有类似的工具么？为什么你要做这个？首先可以说的是全球范围来看，是有的，但是就国内的情况来看，貌似还真没有类似的工具，至少，我们的某些思路和特色能力，是很多同类工具所没有的。   
  &nbsp;&nbsp;&nbsp;&nbsp;目前国内的云厂商Serverless和对应的命令行工具如下：
  
  * 阿里云：Funcraft
  * 百度云：BSAM-CLI
  * 华为云：Serverless Sandbox
  * 腾讯云：Serverless Framework（是腾讯与其独家合作，目前其官方维护的版本在国内只支持腾讯云）
  
  在这些工具中，每个工具有自己的规范标准，有自己的形式和特色，也有着自己的操作方法，有的是命令式的，有的是资源描述式的，这在给广大开发者使用的时候，带来了超级多的不便利，而Serverless Devs Tool目的是要改变这种尴尬的局面，一个工具，可以兼容这些厂商，并且提供多种完整的行业解决方案，开放思路建设应用中心，每个人都是Serverless贡献者，组件化+插件化的模式，让Serverless Devs Tool变得更加灵活！
  
  最后放上一个我们的"用爱发电"的"小目标"：
  
  ![](https://images.serverlessfans.com/s-tool/zh/introduce-1.jpg)   

* 工具特色
   - 组件化和插件化同时存在，在使用组件的时候，可以在开始或者结束自动化执行某些hook指令或者某些插件/脚本，让自动化变得更加简单；
   - 泛指令的支持，目前无论是那个厂商开发的功能，理论上都是没有泛指令的支持，而我们是将这份能力开放给组件开发者，组件开发者可以自定义自己的组件需要哪些命令，需要哪些能力，你可以定义`s project deploy`还可以定义`s project dev`甚至是`s project go`等，我们对您定义的指令，只要遵守规范，我们就不会做任何额外的限制；
   - 与GUI深度结合，我们将很多GUI的思路与工具进行了一个融合，一方面屏蔽掉了恼人的`yaml`，另一方面也将会给您更大的方便和便利，只需要按照要求填写表单，就可以部署一个项目，从此使用Serverless再也不用担心有哪些参数、参数含义的问题了，我们的GUI帮你解决这个问题；
   - 拥有一个完全开放的应用中心，作为一个社区的产品，作为一个开源开放的产品，我们真诚希望每个小伙伴可以和我们共建这样的一个Serverless生态，所以我们开放了一个应用中心，每一个开发者都可以通过`s platform publish`将自己的应用共享给全部的Serverless爱好者，也可以通过`s search`来搜索自己需要的组件/应用，也许前期您搜索到的东西未必是自己需要的，或者搜索不到自己需要的，但是我们相信，随着大家一同来Serverless，一起来贡献，这个应用中心，注定繁荣，撑起我们每一个开发者共同的Serverless梦；  
   - 除此之外，我们还有组件的前后关联，部署顺序，多云账号管理，自由账号管理......超级多的能力！
    
* 发起人想说

     &nbsp;&nbsp;&nbsp;&nbsp;Hey，各位小伙伴大家好哇，我是Serverless Devs Tool的发起人，我是江昱。    
     &nbsp;&nbsp;&nbsp;&nbsp;我从毕业开始，就一直在参与建设Serverless相关产品，也在不同的云厂商待过，做过不同的岗位，Serverless一直都是我努力的方向，所以你可以认为我是Serverless的狂热者。但是看到Serverless的目前发展情况，我却倍感心痛：这应该是一个全民福利，怎么变成了云厂商绑定的特定能力？    
     &nbsp;&nbsp;&nbsp;&nbsp;所以，带着这份心痛，和我对Serverless的挚爱，邀请了一群Serverless的爱好者一同来开发这样一个工具，这只是一个开始，未来还有更多的能力，更多的形态，更多的......      
     &nbsp;&nbsp;&nbsp;&nbsp;我做这个工具，就坚信一件事：能给开发者带来便利就可以：
     ![](https://images.serverlessfans.com/s-tool/zh/introduce-2.jpg) 
     这是一个社区工具， 别问我有没有竞品，别问我和竞品的区别是什么，也别问我未来的盈利模式，这就是一个社区驱动的开发者工具，目的很简单，很纯粹。
      &nbsp;&nbsp;&nbsp;&nbsp;最后，想呼吁一下所有的小伙伴，Serverless是一个说新不新，不新却很新的一个技术或者是一个架构，在这样的一个大环境下，只有我们每个人来贡献Serverless能力，才能让Serverless生态更加繁荣，如果您想要为爱发电，我作为发起人，双手赞同，给你一个大大拥抱，如果你觉得你有想法，也想贡献Serverless，但是又不想影响自己太多的生活，那么我也会和小伙伴们自掏腰包，给您强大的赞助，支持，我的原则是：穷，不能穷死想，苦，不能苦贡献者，所以加入Serverless的开发者大军：云厂商主导Serverless，不如让我们开发者自己主导自己要用的产品！