"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeleteManager = void 0;
var fs = require('fs');
var os = require('os');
var path = require('path');
var yaml = require('js-yaml');
var logger_1 = require("../../utils/logger");
var config_delete_error_1 = require("../../error/config-delete-error");
var DeleteManager = /** @class */ (function () {
    function DeleteManager() {
        this.findProviderAliasFlag = true;
        this.globalPath = path.join(os.homedir(), '.s/access.yaml');
    }
    DeleteManager.prototype.init = function (providerAlias) {
        return __awaiter(this, void 0, void 0, function () {
            var userInformation, userInformationKey, userInformationKey_1, userInformationKey_1_1, item, err_1;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        userInformation = yaml.safeLoad(fs.readFileSync(this.globalPath, 'utf8'));
                        if (!(providerAlias['Provider'] && providerAlias['AliasName'])) return [3 /*break*/, 5];
                        this.provider = String(providerAlias['Provider']).toLocaleLowerCase();
                        this.aliasName = String(providerAlias['AliasName']).toLocaleLowerCase();
                        this.inputProviderAlias = this.provider + "." + (this.aliasName || 'default');
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        userInformationKey = Object.keys(userInformation);
                        try {
                            for (userInformationKey_1 = __values(userInformationKey), userInformationKey_1_1 = userInformationKey_1.next(); !userInformationKey_1_1.done; userInformationKey_1_1 = userInformationKey_1.next()) {
                                item = userInformationKey_1_1.value;
                                if (item === this.inputProviderAlias) {
                                    delete userInformation[item];
                                    this.findProviderAliasFlag = !this.findProviderAliasFlag;
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (userInformationKey_1_1 && !userInformationKey_1_1.done && (_a = userInformationKey_1.return)) _a.call(userInformationKey_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        return [4 /*yield*/, this.isSuccessDle(userInformation)];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _b.sent();
                        throw new config_delete_error_1.ConfigDeleteError('The configuration list is empty. You can add configuration through: s config add');
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        if (!providerAlias['Provider'] || !providerAlias['AliasName']) {
                            //没有一起输入provider 和alias
                            throw new config_delete_error_1.ConfigDeleteError('Need to enter provider and aliasName at the same time. You can obtain the key information through: s config delete -h.');
                        }
                        _b.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    DeleteManager.prototype.isSuccessDle = function (userInformation) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.findProviderAliasFlag) return [3 /*break*/, 2];
                        return [4 /*yield*/, fs.writeFileSync(this.globalPath, yaml.dump(userInformation))];
                    case 1:
                        _a.sent();
                        logger_1.default.success('Deletion succeeded');
                        return [3 /*break*/, 3];
                    case 2: throw new config_delete_error_1.ConfigDeleteError('The key information is not found. You can obtain the key information through: s config get -l.');
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return DeleteManager;
}());
exports.DeleteManager = DeleteManager;
//# sourceMappingURL=delete-manager.js.map