"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetManager = void 0;
var config_get_error_1 = require("../../error/config-get-error");
var os = require('os');
var fs = require('fs');
var path = require('path');
var yaml = require('js-yaml');
var common_1 = require("../../utils/common");
var common_2 = require("../common/common");
var logger_1 = require("../../utils/logger");
var GetManager = /** @class */ (function () {
    function GetManager() {
        this.localPath = path.join(process.cwd(), '/access.yaml');
        this.globalPath = path.join(os.homedir(), ".s/access.yaml");
        this.programArgsLength = 0;
        this.resUserInformation = {};
        if (!fs.existsSync(this.globalPath)) {
            fs.writeFileSync(this.globalPath, '');
        }
    }
    GetManager.prototype.initAccessData = function (userInput) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getManager(userInput, this.localPath)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.getManager(userInput, this.globalPath)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GetManager.prototype.getManager = function (userInput, filePath) {
        return __awaiter(this, void 0, void 0, function () {
            var userInformation_1, provider_1, userInformationKey, aliasName, item;
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    try {
                        userInformation_1 = yaml.safeLoad(fs.readFileSync(filePath, 'utf8'));
                    }
                    catch (ex) {
                        if (filePath === this.globalPath) {
                            fs.writeFileSync(this.globalPath, '');
                        }
                    }
                    if (userInformation_1 !== null) {
                        if (userInput['Provider']) {
                            provider_1 = String(userInput['Provider']).toLocaleLowerCase();
                            userInformationKey = Object.keys(userInformation_1);
                            if (userInput['AliasName']) {
                                aliasName = String(userInput['AliasName']).toLocaleLowerCase();
                                this.providerAlias = this.localPath === filePath ? aliasName : provider_1 + "." + aliasName;
                                userInformationKey.forEach(function (item) {
                                    if (item === _this.providerAlias) {
                                        _this.resUserInformation[_this.providerAlias] = userInformation_1[_this.providerAlias];
                                    }
                                });
                            }
                            else {
                                userInformationKey.forEach(function (item) {
                                    if (_this.localPath === filePath) {
                                        _this.resUserInformation["project." + item] = userInformation_1[item];
                                    }
                                    else if (item.split('.')[0] === provider_1) {
                                        _this.resUserInformation[item] = userInformation_1[item];
                                    }
                                });
                            }
                        }
                        else if (userInput['List']) {
                            for (item in userInformation_1) {
                                if (filePath === this.localPath) {
                                    this.resUserInformation["project." + item] = userInformation_1[item];
                                }
                                else {
                                    this.resUserInformation[item] = userInformation_1[item];
                                }
                            }
                        }
                    }
                    else {
                        if (this.localPath !== filePath) {
                            throw new config_get_error_1.ConfigGetError('Query failed : User configuration is empty');
                        }
                    }
                }
                catch (ex) {
                    this.resUserInformation = {};
                }
                return [2 /*return*/];
            });
        });
    };
    //返回单个provider.alias的值
    GetManager.prototype.getUserSecretID = function (userInput) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.resUserInformation !== null) {
                    if (userInput['Provider'] && userInput['AliasName']) {
                        return [2 /*return*/, this.resUserInformation[userInput['AliasName']] || this.resUserInformation[this.providerAlias]];
                    }
                    // await this.initAccessData(userInput)
                    return [2 /*return*/, this.resUserInformation];
                }
                throw new config_get_error_1.ConfigGetError('Query failed : Please input right format. You can obtain the key information through: s config get -h');
            });
        });
    };
    GetManager.prototype.outputFormat = function (resUserInformation) {
        var sortUserKey = Object.keys(resUserInformation).sort(function (a, b) {
            if (a < b) {
                return -1;
            }
            else if (a > b) {
                return 1;
            }
            return 0;
        });
        var sortUserKeyLength = sortUserKey.length;
        for (var i = 0; i < sortUserKeyLength; i++) {
            var provider = sortUserKey[i].split('.')[0];
            var aliasName = sortUserKey[i].split('.')[1];
            var resObject = resUserInformation[sortUserKey[i]];
            if (i === 0 || sortUserKey[i - 1].split('.')[0] != sortUserKey[i].split('.')[0]) {
                if (common_2.providerObject[provider]) {
                    logger_1.default.info(common_2.providerObject[provider] + "(" + provider + ")");
                }
                else {
                    logger_1.default.info("" + provider);
                }
            }
            logger_1.default.log(" ");
            logger_1.default.info("   AliasName: " + aliasName);
            // eslint-disable-next-line guard-for-in
            for (var item in resObject) {
                var valueOfKey = item;
                var valueOfValue = resObject[item];
                var valueOfValueLength = valueOfValue.length;
                valueOfValue = valueOfValueLength > 6 ? valueOfValue.slice(0, 3) + common_1.printn(valueOfValueLength - 6, '*') + valueOfValue.slice(valueOfValueLength - 3, valueOfValueLength) : valueOfValue;
                logger_1.default.info("   " + valueOfKey + ": " + valueOfValue + " ");
            }
            // for (let [valueOfKey, valueOfValue] of Object.entries(resObject)) {
            //   const valueOfValueLength: any = valueOfValue.length;
            //   valueOfValue = valueOfValueLength > 6 ? valueOfValue.slice(0, 3) + printn(valueOfValueLength - 6, '*') + valueOfValue.slice(valueOfValueLength - 3, valueOfValueLength) : valueOfValue;
            //   logger.info(`   ${valueOfKey}: ${valueOfValue} `);
            // }
            logger_1.default.info(" ");
        }
    };
    GetManager.prototype.consoleRes = function () {
        if (Object.keys(this.resUserInformation).length > 0) {
            this.outputFormat(this.resUserInformation);
        }
        else {
            throw new config_get_error_1.ConfigGetError('Query failed : The key information is not found. You can obtain the key information through: s config get -l');
        }
    };
    return GetManager;
}());
exports.GetManager = GetManager;
//# sourceMappingURL=get-manager.js.map