"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlatformDeleteManager = void 0;
var axios_1 = require("axios");
var logger_1 = require("../../utils/logger");
var platform_delete_error_1 = require("../../error/platform-delete-error");
var static_variable_1 = require("../../utils/static-variable");
var PlatformDeleteManager = /** @class */ (function () {
    function PlatformDeleteManager() {
    }
    PlatformDeleteManager.prototype.delete = function (name, version, type, provider, user) {
        return __awaiter(this, void 0, void 0, function () {
            var options, result, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = {
                            url: static_variable_1.SERVERLESS_DELETE_PACKAGE_URL,
                            method: 'delete',
                            timeout: 5000,
                            headers: {
                                'User-Agent': 's'
                            },
                            params: {
                                name: name,
                                version: version,
                                type: type,
                                provider: provider,
                                user: user
                            }
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        logger_1.default.info('Deleting......');
                        return [4 /*yield*/, axios_1.default.request(options)];
                    case 2:
                        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                        // @ts-ignore
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        throw new platform_delete_error_1.PlatformDeleteError('Failed to delete package, error: {{error}}', { error: err_1.message });
                    case 4:
                        if (result.status != 200) {
                            throw new platform_delete_error_1.PlatformDeleteError('Failed to delete package, http status code: {{code}}', { code: result.status });
                        }
                        if (result.data.Error) {
                            throw new platform_delete_error_1.PlatformDeleteError('Failed to delete package, code: {{code}}, message: {{msg}}', {
                                code: result.data.Error.Code,
                                msg: result.data.Error.Message
                            });
                        }
                        logger_1.default.success('Delete successfully');
                        return [2 /*return*/];
                }
            });
        });
    };
    return PlatformDeleteManager;
}());
exports.PlatformDeleteManager = PlatformDeleteManager;
//# sourceMappingURL=platform-delete-manager.js.map