"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlatformInitManager = void 0;
var fs = require("fs-extra");
var path = require("path");
var platform_init_error_1 = require("../../error/platform-init-error");
var logger_1 = require("../../utils/logger");
var PlatformInitManager = /** @class */ (function () {
    function PlatformInitManager() {
    }
    PlatformInitManager.prototype.init = function (type) {
        type = type.toLocaleLowerCase();
        if (type !== 'component' && type !== 'plugin' && type != 'application') {
            throw new platform_init_error_1.PlatformInitError('Unknown package type: {{type}}', { type: type });
        }
        logger_1.default.info('Initializing......');
        var srcDir = path.join(__dirname, "../../../templates/" + type + "/common");
        fs.copySync(srcDir, process.cwd());
        logger_1.default.success('Initialization successfully');
    };
    return PlatformInitManager;
}());
exports.PlatformInitManager = PlatformInitManager;
//# sourceMappingURL=platform-init-manager.js.map